﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using System.Collections;

namespace UltraComboEditor
{
    public partial class Form1 : Form
    {
        List<Infragistics.Win.UltraWinEditors.UltraComboEditor> cmbChildOrderResults;
        DataTable dt = new DataTable();

        private int lineNumer;

        public Form1()
        {
            InitializeComponent();
            lineNumer = 0;
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.Override.AllowRowFiltering = Infragistics.Win.DefaultableBoolean.True;



            cmbChildOrderResults = new List<Infragistics.Win.UltraWinEditors.UltraComboEditor>();
            int comboCount = 0;


            /*foreach (UltraGridRow ugr in this._twgChildOrders.Rows)
            {
                Infragistics.Win.UltraWinEditors.UltraComboEditor combo = new Infragistics.Win.UltraWinEditors.UltraComboEditor();
                combo.CheckedListSettings.CheckBoxStyle = Infragistics.Win.CheckStyle.CheckBox;
                combo.CheckedListSettings.EditorValueSource = Infragistics.Win.EditorWithComboValueSource.SelectedItem;
                combo.DropDownStyle = Infragistics.Win.DropDownStyle.DropDownList;
                combo.CheckedListSettings.ListSeparator = ",";
                combo.Nullable = true;

                List<string> testList = new List<string>();
                testList.Add("a");
                testList.Add("b");
                testList.Add("c");
                testList.Add("d");
                testList.Add("e");
                testList.Add("f");
                testList.Add("g");
                //combo.Items.Add(ugr.Cells["bbb"].Value.ToString(), ugr.Cells["aaa"].Value.ToString());
                for (int i = 0; i < testList.Count; i++)
                {
                    combo.Items.Add(testList[i]);
                }
                combo.SelectedIndex = 1;


                cmbChildOrderResults.Add(combo);

                ugr.Cells["Label"].EditorComponent = cmbChildOrderResults[comboCount];

                comboCount++;

            }*/

            this._twgChildOrders.DisplayLayout.Override.CellClickAction = Infragistics.Win.UltraWinGrid.CellClickAction.RowSelect;
            
            this._twgChildOrders.DisplayLayout.Override.CellClickAction = Infragistics.Win.UltraWinGrid.CellClickAction.EditAndSelectText;
        }

        private void _twgChildOrders_InitializeRow(object sender, InitializeRowEventArgs e)
        {
            SetComboEditorPerRow(e.Row);
        }

        private void SetComboEditorPerRow(UltraGridRow ultraGridRow)
        {
            //throw new NotImplementedException();
        }

        private void cOp1(object sender, KeyPressEventArgs e)
        {
            if(e.KeyChar == 13)
            {
                MessageBox.Show("Enter pressed", "Attention");
            }
        }
        DataColumn cNumber;
        private void Form1_Load(object sender, EventArgs e)
        {
            //DataTable dt = new DataTable();
            
            cNumber = dt.Columns.Add("No", typeof(int));
            cNumber.ReadOnly = true;
            cNumber.DefaultValue = lineNumer;

            DataColumn cLabel = dt.Columns.Add("Label", typeof(string));
            DataColumn cOpcode = dt.Columns.Add("Opcode", typeof(string));

            DataColumn cOp1 = dt.Columns.Add("Op1", typeof(string));
            DataColumn cOp2 = dt.Columns.Add("Op2", typeof(string));
            DataColumn cOp3 = dt.Columns.Add("Op3", typeof(string));
            DataColumn cOp4 = dt.Columns.Add("Op4", typeof(string));
            DataColumn cOp5 = dt.Columns.Add("Op5", typeof(string));

            //Infragistics.Win.UltraWinEditors.UltraComboEditor ut = new Infragistics.Win.UltraWinEditors.UltraComboEditor();
            DataColumn cComment = dt.Columns.Add("Comment", typeof(string));
            //cComment = dt.Columns.Add("Comment", typeof(Infragistics.Win.UltraWinEditors.UltraComboEditor));

            //dt.Rows.Add(null,null, "ValueItem1", "Item1");

            _twgChildOrders.DataSource = dt;
        }

        private void ultraComboEditor1_ValueChanged(object sender, EventArgs e)
        {

        }

        private void ultraButton1_Click(object sender, EventArgs e)
        {
            if (dt.Rows.Count == 0)
            {
                lineNumer = 0;
                cNumber.DefaultValue = lineNumer;
                
                dt.Rows.Add();
                iLayOut(sender, e);
            }
            else
            {
                lineNumer = lineNumer + 1;
                cNumber.DefaultValue = lineNumer;
                dt.Rows.Add();
                iLayOut(sender, e);
            }
            
            
            
        }

        private void ultraButton2_Click(object sender, EventArgs e)
        {
            
            for (int i = 0; i<int.Parse(this.ultraNumericEditor1.Value.ToString()); i++)
            {
                if (dt.Rows.Count == 0)
                {
                    lineNumer = 0;
                    cNumber.DefaultValue = lineNumer;
                    dt.Rows.Add();
                    iLayOut(sender, e);
                }
                else
                {
                    lineNumer = lineNumer + 1;
                    cNumber.DefaultValue = lineNumer;
                    dt.Rows.Add();
                    iLayOut(sender, e);
                }
            }
        }

        private void ultraButton3_Click(object sender, EventArgs e)
        {
            if(dt.Rows.Count > 0)
            {
                lineNumer = lineNumer - 1;
                dt.Rows.RemoveAt(dt.Rows.Count - 1);
            }
            
        }

        private void iLayOut(object sender, EventArgs e)
        {
            //e.Layout.Override.AllowRowFiltering = Infragistics.Win.DefaultableBoolean.True;



            cmbChildOrderResults = new List<Infragistics.Win.UltraWinEditors.UltraComboEditor>();
            int comboCount = 0;


            foreach (UltraGridRow ugr in this._twgChildOrders.Rows)
            {
                Infragistics.Win.UltraWinEditors.UltraComboEditor combo = new Infragistics.Win.UltraWinEditors.UltraComboEditor();
                //combo.CheckedListSettings.CheckBoxStyle = Infragistics.Win.CheckStyle.CheckBox;
                combo.CheckedListSettings.EditorValueSource = Infragistics.Win.EditorWithComboValueSource.SelectedItem;
                combo.DropDownStyle = Infragistics.Win.DropDownStyle.DropDownList;
                combo.CheckedListSettings.ListSeparator = ",";
                combo.Nullable = true;

                combo.AutoCompleteMode = Infragistics.Win.AutoCompleteMode.SuggestAppend;
                
                List<string> testList = new List<string>();
                testList.Add("aba");
                testList.Add("abcb");
                testList.Add("abcd");
                testList.Add("abcde");
                testList.Add("abcdef");
                testList.Add("abcdefg");
                testList.Add("abcdg");
                //combo.Items.Add(ugr.Cells["bbb"].Value.ToString(), ugr.Cells["aaa"].Value.ToString());
                for (int i = 0; i < testList.Count; i++)
                {
                    combo.Items.Add(testList[i]);
                }
                combo.SelectedIndex = 1;


                cmbChildOrderResults.Add(combo);

                ugr.Cells["Opcode"].EditorComponent = cmbChildOrderResults[comboCount];

                comboCount++;

            }

            this._twgChildOrders.DisplayLayout.Override.CellClickAction = Infragistics.Win.UltraWinGrid.CellClickAction.RowSelect;

            this._twgChildOrders.DisplayLayout.Override.CellClickAction = Infragistics.Win.UltraWinGrid.CellClickAction.EditAndSelectText;
        }
    }
}
